\ job.fs -- 850 Test App with Standalone Interpreter -- 21Sep13 rjn
\
false   constant tethered
true    constant turnkeyed
true    constant standalone

\ -----[ configure for 300 Dev ]
	$200  constant start        \ Reset vector.  Bootloader at $0000.
	$20B  constant TIM0         \ timer 0 interrupt
   $21B  constant TIM1         \ timer 1 overflow interrupt
   $223  constant RI           \ serial receive interrupt
   $22B  constant TIM2         \ timer 2 overflow interrupt
   $233  constant rom-start    \ start of code ($22b + $08)
   $1fff constant target-size  \ 8K flash
\ 
true constant cs?  \ produce compilation summary?
\ 
\ -----[ load MyForth system ] 
include mide-loader.fs
\ 
\ -----[ define SFRs, generate bootloader image ]
include sfr85x.fs
include bootloader850.fs 
\ 
\ version string is placed here by ver$
rom-start [ 20 + ] org  \ leave room for version string ver$
include serial.fs  \ serial I/O, strings
here rom-start org  -: ver$ string " DACS b31024" ; org  \ version string
\ 
include 25_delays.fs    \ 25 MHz delays
include analog.fs       \ analog register management
include dacs-init.fs    \ chip initialization, I/O primitives
include utils.fs        \ misc. utils -- load before application
\ 
\ -----[ include interpreter(s) ] 
tethered   [if] include mide-tether.fs      [then]
standalone [if] include dacs-standalone.fs  [then]
\ 
\ -----[ load the application ] 
\ 
\ dacs.txt           \ text link to doc file
\ [ cr ]                    \ whitespace for compilation summary
include hextools.fs       \ enter hex number on stack
include ipp-stack.fs      \ 
include commands.fs       \ 
include adc-commands.fs
include main.fs           \ initialization, go definition
\ include interactive.fs    \ Should come _after_ application for efficiency.
[ cr cr ] 
\ 
\ -----[ patch the reset vector ]
turnkeyed [if]	\ Turnkeyed with go.
	start interrupt : cold stacks go ;      \ patch reset to go 
[else]	        \ Testing with quit.
	start interrupt : cold stacks quit ;
[then]
\ 
\ -----[ select interactive or standalone ]
tethered [if]  \ interactive number entry
	:m # tnumber emit-s m;
	:m ## [ dup 8 rshift $ff and swap $ff and ] # # m;
[then]  
\
standalone [if]  \ standalone - patch dictionary pointer
\ Note: see config.fs -- headers are tacked on (moved) to the end of code by "headers"
        : r   cold ;
        headers ] here [ dict org heads ##p! org ] 
        [ .( heads start at: ) heads .  .(  size: ) ] 
		here [ heads - .  .(  bytes) ]
	here ( *) patch-cold org cold ( *) org  \ patch cold (after end of heads)
[then]
\
\ -----[ report build statistics ]
report
save
[ .( Host stack= ) .s
cr target-size ] here [ - .  .( bytes flash available) cr ]

