\ standalone.fs  command interpreter for itest project -- 09Aug13 rjn

0 [if]
Copyright (C) 2004-2006 by Charles Shattuck.

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

For LGPL information:   http://www.gnu.org/copyleft/lesser.txt

[then]
\ 
] here ( *start)
\ 
\ : emit begin 1 .SCON until. 1 .SCON clr SBUF #! ;
\ : key  begin 0 .SCON until. 0 .SCON clr SBUF #@ ;
\ 
-: echo dup emit ;
-: space BL # emit ;
-: cr 13 # emit 10 # emit ;
\ 
\ -----[ errors ]
\
:m err    [ 0 .p0 ] m;
-: led-on  [ err clr ] ;

2 constant tib  \ begins after S, and A.

\ 
\ err? is set/cleared on error, ok execution
cpuHere constant err? 1 cpuAllot  \ true=error, false=ok
\ 
\ accumulates errors until cleared
cpuHere constant #errs 1 cpuAllot  \ contains total error count
\ 
-: /#errs     0 # #errs #! ;
-: /err?      0 # err?  #!  [  err set ]  ;
\ -: !err     $ff # err? #!  led-on  ;
-: !err     tib #@ if $ff # err? #!  led-on then drop  ;
\ 
\ -: ok   cr err? #@ if drop [ char > ] #  emit ; then drop 
\            [ char ? ] # emit [ #errs inc ] led-on ;
\ 
-: emit>  cr here ( *) nop nop nop [ char > ] #  emit ;
( *) constant epatch
\

\ 
\ if not in "respond" mode, use error output to indicate command completion
-: ?complete  emit? #@ 0=if led-on then drop ;
-: ok 
   tib  #@ 0=if drop emit> ; then drop \ no entry, no error, normal prompt
   err? #@   if [ char ? ] # emit  
      [ #errs inc ] then drop emit> ;
\ 
-: 2dup |over |over ;
-: min 2dup swap
-: clip negate + -if push swap pop then 2drop ;
-: max 2dup clip ;
-: p |p ;
-: @p |@p ;    
-: @p+ |@p+ ;  
\ 
\ -: depth [ SP0 -2 + ] # S #@ negate + ;
-: depth S #@ invert ;
\ 
\ see job.fs to see how this is patched
-: huh?   here ( *) nop nop nop ;  constant patch-cold

\ debug version, allow stack items
\ -: ?stack   depth -if huh? ; then drop  depth if huh? ; then drop ;
-: ?stack  depth 0=if drop ; then huh? ; \ nothing on stack for this app.

-: match ( ? - ?) @+ @p+ xor ior ;  \ 0 if still a match.
-: word 0 # tib # a! match match match match ;
\ -: ?digit [ char 0 negate ] # + -if huh? then -10 # + +if huh? then
\  10 # + ;
\ -: number tib # a! 0 # @+ 3 # min begin swap 10 # (*) @+ ?digit + swap
\ -: number tib # a! 0 # @+ 3 # min begin swap 10 # |* @+ ?digit + swap
\   1- 0=until drop ;
-: find @p if drop word if drop p+ p+ find ; then invert ; then drop
   0 # ;

here constant dict  \ Patch this later with real dictionary.
\ headers ] here [ dict org heads ##p! org ]  \ like this

-: dictionary 0 ##p! ;
-: interpret p push push a push dictionary find if
   drop @p+ @p pop a! pop pop p! push push ; then drop 
   ( number)  \ ignore number
   !err
   pop a! pop pop p! ;
-: tib! ( c) a push tib #@ 1+ tib #! tib # dup a! @ + 6 # min a! ! pop a! ;
-: 0tib tib # dup a! 0 # dup !+ dup !+ dup !+ dup !+ ! a! ;

1 [if] \ ----------------------------------------------------------------------
\ Patch out for special numeric processing (e.g., "#" and "$").
-: query 0tib
-: back key 8 # =if drop cr query ; then BL # max echo BL # xor if
   BL # xor tib! back ; then drop ;
-: quit query interpret ?stack ok quit ;
[then] \ ----------------------------------------------------------------------

\ Standalone Notes by rjn:
\ 1. The "BL # max" in back allows up to 32 chars as the tib count.
\ 2. The "BL # xor if" terminates input on a blank.
\ 3. The "BL # xor tib!" gets the char if it isn't a blank and puts
\    in the tib, updating the count in the first cell of tib ( i.e., tib).
\ 4. Each dictionary entry takes 6 bytes (cnt, 3 chars, 2 adr).

 here  [ swap -  cr .( standalone         ) . .( bytes) ]
\ 
\ 
0 [if] ---------------------[ Revision History ]-------------------------------

Date	By  Description
======= === ==============================================================
        rjn dcon production
04April rjn added this revision history, comment changes

[then] \ ----------------------------------------------------------------------
